'use strict';

(function() {
	const _t = init('com.crocro.util');

	// bresenham | ブレゼンハムのアルゴリズム
	_t.bresenham = function(x0, y0, x1, y1, setPixel) {
		const dx = Math.abs(x1 - x0);
		const dy = Math.abs(y1 - y0);
		const sx = (x0 < x1) ? 1 : -1;
		const sy = (y0 < y1) ? 1 : -1;
		let err = dx - dy;

		while (true) {
			setPixel(x0, y0);
			if ((x0 == x1) && (y0 == y1)) {break}
			const e2 = err << 1;
			if (e2 > -dy) {err -= dy; x0  += sx}
			if (e2 <  dx) {err += dx; y0  += sy}
		}
	};

	// 初期化用関数
	function init(p) {
		try {return module.exports = {}} catch(e) {}
		return ((o, p) => {
			p.split('.').forEach(k => o = o[k]||(o[k]={}));
			return o})(window, p);
	};
})();
